SystemOrganization addCategory: #'Conman-Core'!
SystemOrganization addCategory: #'Conman-Core-Tests'!
SystemOrganization addCategory: #'Conman-Web'!
SystemOrganization addCategory: #'Conman-Web-Components'!

WAFileLibrary subclass: #CMFileLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Conman-Web'!

!CMFileLibrary methodsFor: 'uploaded' stamp: ''!
conmanCss
	^ '/* Colors:
 * Dark blue:	#000099
 * Grey: 		#999999

/* General Formatting */
* {
	font-family: Georgia, serif;
}

body {
	background-color: black;
}

.busy * {
	cursor: progress;
}

/* Heading */
#heading {
	position: absolute;
	top: 0px;
	right: 0px;
	background: #000099 url("crossover.png") no-repeat;
	padding-left: 155px;
	padding-right: 5px;
	height: 60px;
	z-index: 3;
}

#heading h1 {
	margin-top: 2px;
	margin-bottom: 2px;
	font-size: 24pt;
	text-align: right;
	color: #ffcc00;
}

#heading p {
	color: #cccccc;
	margin-top: 2px;
	text-align: right;
	font-size: 8pt;
}

#heading input.editor_field {
	font-size: 21pt;
}

/* Navigation and Menu */
#nav a {
	text-decoration: none;
	font-size: 8pt;
	color: #cccccc;
}

#nav {
	position: absolute;
	padding: 0;
	top: 0px;
	left: 0px;
	background: #000099 url("nav-left.png") no-repeat;
	height: 20px;
	z-index: 3;
}

#nav ul {
	margin: 0;
	padding: 0 0 0 20px;
	height: 20px;
}

#nav li {
	float: left;
	height: 100%;
	padding: 0 0.2em 0 0.2em;
	top: auto;
	bottom: auto;
	list-style: none;
}

#nav li a {
	
}

#nav li.active a {
	color: white;
}

/* Page heading */
#pageHeading {
	position: absolute;
	top: 0;
	left: 0;
	right: 0;
	padding-left: 20px;
	padding-top: 25px;
	margin: 0;
	height: 35px;
	background: #999999 url("nav.png") repeat-x;
	z-index: 2;
}

#pageHeading h2 {
	text-align: left;
	font-size: 18pt;
	margin: 0;
	color: black;
}

/* Page Body */
#pageBody {
	padding: 20px;
	background: white url("top-left.png") no-repeat;
	position: absolute;
	top: 60px;
	bottom: 0px;
	left: 0px;
	right: 0px;
	z-index: 0;
	overflow: auto;
}

/* Content area */
#content {
	position: absolute;
	right: 20px;
	bottom: 0;
	top: 10px;
	left: 17.5em;
}

/* Sidebar view */
#sidebar {
	position: absolute;
	padding-left: 0;
	padding-top: 20px;
	padding-right: 0.5em;
	border-right: dashed 1px #ff9933;
	width: 15em;
	bottom: 0;
	top: 0;
}

#sidebar table {
	font-size: 0.8em;
	border: 0 dashed #999999;
	padding: 0;
	width: 100%;
	margin-bottom: 1em;
	border-spacing: 0;
}

#sidebar table a {
	text-decoration: none;
	color: inherit;
}

#sidebar td.num {
	text-align: right;
	padding-right: 0.5em;
}

#sidebar th {
	font-weight: normal;
}

#sidebar tr.head,#sidebar tr.head:hover {
	background-color: #000099;
	color: #dddddd;
}

#sidebar tr.odd {
	background-color: #dddddd;
}

#sidebar tr.even {
	background-color: #eeeeee;
}

#sidebar tr:hover {
	background-color: #ff9933;
}

#sidebar tr.current,#sidebar tr.current:hover {
	background-color: white;
	color: #999999;
}

#sidebar tr.even td.actions {
	background-color: #eeeeee;
}

#sidebar tr.odd td.actions {
	background-color: #dddddd;
}

#sidebar td.actions a {
	color: #cc6600;
}

#sidebar td.actions a:hover {
	color: #ff9933;
}

/* View */
#view {
	position: absolute;
	bottom: 0;
	top: 0;
	left: 0;
	right: 0;
}

#view h3 {
	margin: 0 0 0.5em 0;
}

#view ul.itemTabs {
	margin: 5px 0 0 0;
	padding-left: 0;
	font-size: 0.8em;
}

#view .itemTabs li {
	display: inline;
	margin: 0;
	padding: 2px 5px 3px 5px;
	background-color: #cccccc;
}

#view .itemTabs a {
	text-decoration: none;
	color: black;
}

#view .itemTabs a:hover {
	color: #cc6600;
}

#view .itemTabs .active {
	background-color: #eeeeee;
}

#view .itemTabs .active a {
	color: #999999;
}

#viewContent {
	margin: 0;
	padding: 0.5em;
	background-color: #eeeeee;
}

#viewContent p {
	margin: 0.1em 0.2em 0.2em 3em;
	text-align: justify;
}

#viewContent .label {
	float: left;
	margin-left: 0;
	font-size: 0.8em;
	font-style: italic;
	width: 3em;
	text-align: right;
	color: #000099;
}

span.fixFloats {
	clear: both;
	display: block;
}

/* Lightbox effects */
div#lightbox {
	background: white;
	border: 1px solid #cc6600;
	padding: 2em;
	width: 10em;
	text-align: center;
}
div#overlay {
	background-color: black;
	filter: alpha(opacity=30);
	-moz-opacity: 0.3;
	opacity: 0.3;
}'! !

!CMFileLibrary methodsFor: 'uploaded' stamp: ''!
crossoverPng
	| cache |
	cache := #(nil) beMutable.
	(cache at: 1) isNil ifTrue: [
		cache at: 1 put: #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 155 0 0 0 60 8 2 0 0 0 254 26 95 141 0 0 0 4 103 65 77 65 0 0 175 200 55 5 138 233 0 0 0 25 116 69 88 116 83 111 102 116 119 97 114 101 0 65 100 111 98 101 32 73 109 97 103 101 82 101 97 100 121 113 201 101 60 0 0 3 29 73 68 65 84 120 218 236 156 77 47 123 65 20 198 79 81 111 11 194 130 8 162 44 72 68 67 132 196 66 8 214 62 96 191 137 216 88 80 68 90 141 72 211 160 26 213 168 86 27 165 84 83 245 118 158 255 109 234 61 146 134 127 110 167 207 47 99 50 238 238 222 95 207 153 115 103 58 117 136 120 132 24 68 29 31 1 141 18 26 37 52 74 104 148 208 40 141 18 26 37 52 74 104 148 208 40 141 18 26 37 52 74 104 148 208 40 141 18 26 37 52 74 126 157 6 143 71 138 69 137 199 223 93 77 165 36 159 47 141 175 174 228 250 26 131 179 51 121 124 148 251 123 57 63 231 115 179 177 81 253 115 58 101 96 224 221 213 15 255 126 73 44 6 193 218 91 142 245 19 160 159 131 104 148 143 212 6 70 43 163 191 31 189 203 245 241 122 50 41 23 23 232 19 9 57 61 197 184 28 238 196 214 70 191 163 187 27 205 237 126 189 146 205 194 174 58 214 128 214 62 28 150 135 7 62 249 234 49 250 153 182 54 180 225 225 215 43 145 8 188 106 127 124 12 223 164 202 140 126 102 104 8 205 66 211 178 170 61 56 128 93 141 96 82 149 70 223 210 213 133 54 51 131 241 205 13 98 119 127 95 130 65 212 216 164 2 28 30 143 77 79 73 232 203 210 222 158 132 66 114 120 72 77 70 24 125 91 88 5 2 176 171 129 75 76 48 90 38 151 147 221 93 217 222 70 102 38 38 24 45 147 78 203 214 150 108 108 112 174 53 197 104 25 157 101 53 100 53 39 23 10 84 105 132 81 11 213 233 247 139 215 203 108 108 138 209 50 177 152 172 173 201 206 14 246 30 106 150 250 229 229 101 99 110 166 189 93 198 199 101 126 94 154 155 177 121 80 155 169 216 168 24 125 203 211 19 10 99 13 217 90 75 197 13 166 222 88 93 157 76 77 161 105 42 94 93 21 159 15 142 153 117 13 73 197 147 147 88 101 124 126 198 58 148 241 94 205 55 106 209 218 42 99 99 152 98 157 78 120 53 184 116 170 21 163 22 141 141 50 50 34 139 139 216 221 75 36 228 238 142 70 205 184 231 122 25 28 148 133 5 236 249 164 82 216 240 161 81 35 170 124 135 244 245 33 15 187 92 88 86 204 100 88 235 154 130 219 141 22 137 200 202 10 118 120 24 163 134 208 209 33 211 211 168 138 181 104 210 210 73 11 99 26 53 1 173 152 38 38 100 110 14 57 57 30 175 202 111 184 209 232 23 52 53 201 232 40 74 39 125 151 173 186 146 152 70 191 47 49 26 80 18 47 45 73 111 47 234 166 106 41 157 104 244 103 122 122 100 118 22 213 147 38 225 100 210 238 171 78 198 174 212 255 17 185 28 246 216 215 215 237 123 248 135 70 43 36 28 134 87 191 223 118 11 138 52 250 11 33 235 245 226 133 135 70 141 66 147 176 207 39 155 155 114 121 73 163 102 17 137 96 225 73 237 166 211 52 106 22 154 135 3 1 156 248 56 57 161 81 179 200 231 113 208 67 91 40 244 63 166 91 174 212 255 57 45 45 248 62 155 54 249 119 84 235 232 8 118 131 65 28 202 99 140 26 69 54 11 181 26 181 86 251 173 121 151 70 237 66 161 80 82 27 141 162 114 214 65 101 191 118 64 163 246 69 95 132 84 173 246 137 132 220 222 98 156 201 252 124 36 158 243 168 125 233 236 68 251 210 180 206 199 197 98 105 37 82 125 91 223 53 183 174 188 8 48 0 137 206 116 80 50 162 251 137 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray ].
	^ cache at: 1! !

!CMFileLibrary methodsFor: 'uploaded' stamp: ''!
navPng
	| cache |
	cache := #(nil) beMutable.
	(cache at: 1) isNil ifTrue: [
		cache at: 1 put: #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 1 0 0 0 20 8 2 0 0 0 195 108 192 246 0 0 0 4 103 65 77 65 0 0 175 200 55 5 138 233 0 0 0 25 116 69 88 116 83 111 102 116 119 97 114 101 0 65 100 111 98 101 32 73 109 97 103 101 82 101 97 100 121 113 201 101 60 0 0 0 20 73 68 65 84 120 218 98 98 96 152 201 196 192 192 64 45 12 16 96 0 52 229 0 194 193 193 233 219 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray ].
	^ cache at: 1! !

!CMFileLibrary methodsFor: 'uploaded' stamp: ''!
navleftPng
	| cache |
	cache := #(nil) beMutable.
	(cache at: 1) isNil ifTrue: [
		cache at: 1 put: #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 20 0 0 0 20 8 2 0 0 0 2 235 138 90 0 0 0 4 103 65 77 65 0 0 175 200 55 5 138 233 0 0 0 25 116 69 88 116 83 111 102 116 119 97 114 101 0 65 100 111 98 101 32 73 109 97 103 101 82 101 97 100 121 113 201 101 60 0 0 0 204 73 68 65 84 120 218 164 148 61 10 131 64 16 70 63 23 45 82 164 177 23 196 34 96 163 96 35 226 5 196 220 192 194 214 198 210 187 136 119 177 243 12 122 0 75 123 17 187 124 169 2 98 80 199 7 219 237 99 102 231 103 181 186 110 170 10 243 12 1 74 41 184 46 100 40 158 215 235 134 28 4 76 64 42 63 159 240 125 169 76 194 240 134 204 200 166 41 149 249 230 52 149 202 36 138 46 7 255 201 186 142 36 145 202 36 142 97 89 82 153 193 179 236 66 207 183 23 29 7 239 183 84 38 44 251 201 105 87 123 187 130 162 128 109 139 100 242 120 160 44 143 253 191 197 225 192 115 207 185 51 18 153 24 198 55 255 60 255 38 178 139 126 248 48 54 223 243 208 182 232 186 237 135 163 53 77 115 178 49 235 138 97 64 223 99 28 177 44 152 38 124 4 24 0 55 19 35 197 40 67 124 174 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray ].
	^ cache at: 1! !

!CMFileLibrary methodsFor: 'uploaded' stamp: ''!
topleftPng
	| cache |
	cache := #(nil) beMutable.
	(cache at: 1) isNil ifTrue: [
		cache at: 1 put: #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 20 0 0 0 20 8 2 0 0 0 2 235 138 90 0 0 0 4 103 65 77 65 0 0 175 200 55 5 138 233 0 0 0 25 116 69 88 116 83 111 102 116 119 97 114 101 0 65 100 111 98 101 32 73 109 97 103 101 82 101 97 100 121 113 201 101 60 0 0 0 211 73 68 65 84 120 218 156 147 187 10 133 48 12 64 211 82 20 81 196 87 17 5 23 21 29 156 116 117 17 5 255 209 239 116 22 110 4 225 122 241 113 219 156 173 109 14 77 147 148 45 203 2 10 184 174 155 166 169 148 50 12 67 206 185 101 89 182 109 139 119 199 52 205 186 174 203 178 140 162 232 122 250 40 11 33 154 166 105 219 214 48 140 199 152 219 221 32 8 230 121 198 84 223 243 186 145 243 60 31 134 1 111 254 91 8 113 53 167 105 98 140 169 84 145 159 23 73 146 140 227 168 104 254 200 88 88 52 177 13 160 204 55 180 239 123 108 29 232 112 200 113 28 99 51 65 147 67 238 186 14 244 217 101 223 247 179 44 35 202 85 85 1 137 93 46 138 130 40 227 36 58 142 67 148 177 206 64 133 227 23 165 203 158 231 145 101 182 174 43 249 205 108 219 54 173 121 62 243 17 96 0 190 204 21 162 12 101 219 221 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray ].
	^ cache at: 1! !

Object subclass: #CMConvention
	instanceVariableNames: 'rooms events participants name filename days'
	classVariableNames: 'Suffix Prefix'
	poolDictionaries: ''
	category: 'Conman-Core'!

!CMConvention class methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 21:44'!
deserialize: aString
	^Object readSixxFrom: aString! !

!CMConvention class methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 22:47'!
filenameFrom: aFilename
	" Use a template to create a filename from the unique portion "
	^ Prefix, aFilename , Suffix.! !

!CMConvention class methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 22:48'!
initialize
	super initialize.
	Prefix := 'Conman-'.
	Suffix := '.xml'.! !

!CMConvention class methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 22:49'!
listSaved
	^ (FileDirectory default fileNamesMatching: Prefix, '*', Suffix) collect: [ :n|
		n copyFrom: Prefix size + 1 to: n size - Suffix size ].! !

!CMConvention class methodsFor: 'as yet unclassified' stamp: 'srh 10/19/2008 13:42'!
loadFrom: aFilename
	| fstream c |
	fstream := FileDirectory default readOnlyFileNamed: (self filenameFrom: aFilename).
	c := Object readSixxFrom: fstream.
	fstream close.
	c filename: aFilename.
	^c! !

!CMConvention methodsFor: 'as yet unclassified' stamp: 'srh 10/19/2008 12:49'!
addDay: aDay
	days add: aDay.! !

!CMConvention methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 20:49'!
addEvent: anEvent
	events add: anEvent.! !

!CMConvention methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 20:50'!
addParticipant: aParticipant
	participants add: aParticipant! !

!CMConvention methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 20:49'!
addRoom: aRoom
	rooms add: aRoom! !

!CMConvention methodsFor: 'as yet unclassified' stamp: 'srh 10/19/2008 12:50'!
days
	^SortedCollection withAll: days! !

!CMConvention methodsFor: 'accessing' stamp: 'srh 10/19/2008 12:51'!
events
	^Set withAll: events! !

!CMConvention methodsFor: 'accessing' stamp: 'srh 10/13/2008 21:04'!
filename
	^filename! !

!CMConvention methodsFor: 'accessing' stamp: 'srh 10/13/2008 20:50'!
filename: aFilename
	filename := aFilename! !

!CMConvention methodsFor: 'initialization' stamp: 'srh 10/19/2008 12:51'!
initialize
	super initialize.
	rooms := Set new.
	events := Set new.
	participants := Set new.
	days := Set new.! !

!CMConvention methodsFor: 'accessing' stamp: 'srh 5/29/2007 23:11'!
name
	^name! !

!CMConvention methodsFor: 'accessing' stamp: 'srh 5/29/2007 23:10'!
name: aName
	name := aName.! !

!CMConvention methodsFor: 'accessing' stamp: 'srh 10/19/2008 12:50'!
participants
	^Set withAll: participants! !

!CMConvention methodsFor: 'as yet unclassified' stamp: 'srh 10/19/2008 12:55'!
removeDay: aDay
	events do: [:e| (e day = aDay) ifTrue: [ e deschedule ]].
	days remove: aDay! !

!CMConvention methodsFor: 'as yet unclassified' stamp: 'srh 10/19/2008 12:57'!
removeEvent: anEvent
	participants do: [:p| p unattend: anEvent].
	events remove: anEvent.! !

!CMConvention methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 21:17'!
removeParticipant: aParticipant
	aParticipant dispose.
	participants remove: aParticipant.! !

!CMConvention methodsFor: 'as yet unclassified' stamp: 'srh 10/19/2008 12:58'!
removeRoom: aRoom
	events do: [:e| (e room = aRoom) ifTrue: [ e deschedule ]].
	rooms remove: aRoom.! !

!CMConvention methodsFor: 'accessing' stamp: 'srh 10/19/2008 12:51'!
rooms
	^Set withAll: rooms! !

!CMConvention methodsFor: 'actions' stamp: 'srh 10/13/2008 20:50'!
save
	self saveAs: filename! !

!CMConvention methodsFor: 'actions' stamp: 'srh 10/13/2008 21:05'!
saveAs: aFilename
	| fstream |
	fstream := FileDirectory default forceNewFileNamed: (CMConvention filenameFrom: aFilename).
	fstream write: self serialize.
	fstream close.! !

!CMConvention methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 21:43'!
serialize
	" Convert the Convention and its members to a string that can be used
	 to reconstitute the Convention via CMConvention deserialise:"
	
	^self sixxString.! !

Object subclass: #CMDay
	instanceVariableNames: 'date start end'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Conman-Core'!

!CMDay class methodsFor: 'as yet unclassified' stamp: 'srh 10/19/2008 11:55'!
date: aDate
	^self basicNew date: aDate;yourself! !

!CMDay methodsFor: 'as yet unclassified' stamp: 'srh 10/19/2008 11:54'!
date
	^date! !

!CMDay methodsFor: 'as yet unclassified' stamp: 'srh 10/19/2008 11:53'!
date: aDate
	date := aDate! !

!CMDay methodsFor: 'as yet unclassified' stamp: 'srh 10/19/2008 13:55'!
dayOfWeekAbbreviation
	^date asDateAndTime dayOfWeekAbbreviation ! !

!CMDay methodsFor: 'as yet unclassified' stamp: 'srh 10/19/2008 11:54'!
end
	^end! !

!CMDay methodsFor: 'as yet unclassified' stamp: 'srh 10/19/2008 11:54'!
end: aTime
	end := aTime! !

!CMDay methodsFor: 'as yet unclassified' stamp: 'srh 10/19/2008 11:54'!
start
	^start! !

!CMDay methodsFor: 'as yet unclassified' stamp: 'srh 10/19/2008 11:53'!
start: aTime
	start := aTime! !

Object subclass: #CMEvent
	instanceVariableNames: 'description duration name room day time'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Conman-Core'!

!CMEvent methodsFor: 'accessing' stamp: 'srh 10/19/2008 12:26'!
day
	^day! !

!CMEvent methodsFor: 'as yet unclassified' stamp: 'srh 10/19/2008 12:32'!
deschedule
	room := nil.
	day := nil.
	time := nil! !

!CMEvent methodsFor: 'accessing' stamp: 'srh 5/23/2007 22:14'!
description
	^ description! !

!CMEvent methodsFor: 'accessing' stamp: 'srh 5/23/2007 22:14'!
description: anObject
	description := anObject! !

!CMEvent methodsFor: 'accessing' stamp: 'srh 5/23/2007 22:14'!
duration
	^ duration! !

!CMEvent methodsFor: 'accessing' stamp: 'srh 5/23/2007 22:14'!
duration: anObject
	duration := anObject! !

!CMEvent methodsFor: 'initialize-release' stamp: 'srh 10/19/2008 12:05'!
initialize
	super initialize! !

!CMEvent methodsFor: 'accessing' stamp: 'srh 5/23/2007 22:15'!
name
	^ name! !

!CMEvent methodsFor: 'accessing' stamp: 'srh 5/23/2007 22:14'!
name: anObject
	name := anObject! !

!CMEvent methodsFor: 'accessing' stamp: 'srh 5/24/2007 15:16'!
room
	^room! !

!CMEvent methodsFor: 'as yet unclassified' stamp: 'srh 10/19/2008 12:12'!
scheduleOn: aDay at: aTime in: aRoom
	day := aDay.
	time := aTime.
	room := aRoom.! !

!CMEvent methodsFor: 'as yet unclassified' stamp: 'srh 10/19/2008 12:35'!
scheduled
	^room notNil and: day notNil and: time notNil.! !

!CMEvent methodsFor: 'as yet unclassified' stamp: 'srh 10/19/2008 12:27'!
time
	^time! !

Object subclass: #CMListColumn
	instanceVariableNames: 'title renderBlock properties condition'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Conman-Web-Components'!

!CMListColumn methodsFor: 'as yet unclassified' stamp: 'srh 10/21/2008 23:36'!
initialize
	properties := OrderedCollection new.
	condition := [:item | true].! !

!CMListColumn methodsFor: 'as yet unclassified' stamp: 'srh 10/21/2008 23:13'!
on: aSymbol
	self titled: (aSymbol asCapitalizedPhrase).
	self	renderedUsing: [ :item | item perform: aSymbol].! !

!CMListColumn methodsFor: 'as yet unclassified' stamp: 'srh 10/21/2008 23:17'!
onlyIf: aBlock
	condition := aBlock! !

!CMListColumn methodsFor: 'as yet unclassified' stamp: 'srh 10/21/2008 23:22'!
property: aSymbol value: aValueOrBlock
	properties add: aSymbol asMutator  -> 
		(aValueOrBlock isBlock 
			ifTrue: [ aValueOrBlock ]
			ifFalse: [ [ :item | aValueOrBlock] ])! !

!CMListColumn methodsFor: 'as yet unclassified' stamp: 'srh 10/21/2008 23:21'!
renderItem: anItem on: html callback: callback
	| t |
	(condition value: anItem) ifTrue: [
		t := html tableData.
		properties do: [ :p | t perform: p key with: (p value value: anItem) ].
 		t with: [
			html anchor callback: [callback value: anItem]; with: (renderBlock value: anItem)]]! !

!CMListColumn methodsFor: 'as yet unclassified' stamp: 'srh 10/20/2008 17:46'!
renderUsing: aBlock
	renderBlock := aBlock! !

!CMListColumn methodsFor: 'as yet unclassified' stamp: 'srh 10/21/2008 23:34'!
renderedUsing: aBlock
	self renderUsing: aBlock! !

!CMListColumn methodsFor: 'as yet unclassified' stamp: 'srh 10/20/2008 18:05'!
title
	^title! !

!CMListColumn methodsFor: 'as yet unclassified' stamp: 'srh 10/20/2008 17:45'!
title: aString
	title := aString! !

!CMListColumn methodsFor: 'as yet unclassified' stamp: 'srh 10/21/2008 23:14'!
titled: aString
	self title: aString! !

Object subclass: #CMParticipant
	instanceVariableNames: 'bio name events'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Conman-Core'!

CMParticipant class
	instanceVariableNames: 'events'!

CMParticipant class
	instanceVariableNames: 'events'!

!CMParticipant methodsFor: 'as yet unclassified' stamp: 'srh 10/19/2008 12:16'!
attend: anEvent
	events add: anEvent! !

!CMParticipant methodsFor: 'accessing' stamp: 'srh 5/23/2007 22:15'!
bio
	^ bio! !

!CMParticipant methodsFor: 'accessing' stamp: 'srh 5/23/2007 22:15'!
bio: anObject
	bio := anObject! !

!CMParticipant methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 21:18'!
dispose
	events do: [ :e | self unattend: e].! !

!CMParticipant methodsFor: 'accessing' stamp: 'srh 5/23/2007 23:20'!
events
	^events! !

!CMParticipant methodsFor: 'as yet unclassified' stamp: 'srh 5/31/2007 20:22'!
initialize
	events := Set new.
	bio := ''! !

!CMParticipant methodsFor: 'private' stamp: 'srh 5/23/2007 23:19'!
myAddEvent: anEvent
	events add: anEvent.! !

!CMParticipant methodsFor: 'private' stamp: 'srh 5/24/2007 07:22'!
myRemoveEvent: anEvent
	events remove: anEvent! !

!CMParticipant methodsFor: 'accessing' stamp: 'srh 5/23/2007 22:16'!
name
	^ name! !

!CMParticipant methodsFor: 'accessing' stamp: 'srh 5/23/2007 22:15'!
name: anObject
	name := anObject! !

!CMParticipant methodsFor: 'as yet unclassified' stamp: 'srh 10/19/2008 12:25'!
timetable
	| t |
	t := SortedCollection sortBlock: [ :a :b | (a day < b day) or: [(a day = b day) and: [a time < b time]]].
	events do: [ :event | 
		event scheduled ifTrue: [
			t add: event.
		]].
	^t.! !

!CMParticipant methodsFor: 'as yet unclassified' stamp: 'srh 10/19/2008 12:16'!
unattend: anEvent
	events remove: anEvent! !

Object subclass: #CMRoom
	instanceVariableNames: 'capacity description name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Conman-Core'!

!CMRoom methodsFor: 'accessing' stamp: 'srh 5/23/2007 22:15'!
capacity
	^ capacity! !

!CMRoom methodsFor: 'accessing' stamp: 'srh 5/23/2007 22:15'!
capacity: anObject
	capacity := anObject! !

!CMRoom methodsFor: 'accessing' stamp: 'srh 5/23/2007 22:15'!
description
	^ description! !

!CMRoom methodsFor: 'accessing' stamp: 'srh 5/23/2007 22:15'!
description: anObject
	description := anObject! !

!CMRoom methodsFor: 'as yet unclassified' stamp: 'srh 10/19/2008 12:02'!
initialize
	super initialize.
	description := ''! !

!CMRoom methodsFor: 'accessing' stamp: 'srh 5/23/2007 22:16'!
name
	^ name! !

!CMRoom methodsFor: 'accessing' stamp: 'srh 5/23/2007 22:15'!
name: anObject
	name := anObject! !

WAComponent subclass: #CMComponent
	instanceVariableNames: 'enabled'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Conman-Web'!

!CMComponent methodsFor: 'accessing' stamp: 'srh 5/29/2007 23:16'!
convention
	^self session convention! !

!CMComponent methodsFor: 'as yet unclassified' stamp: 'srh 5/29/2007 22:11'!
disable
	enabled := false.! !

!CMComponent methodsFor: 'as yet unclassified' stamp: 'srh 5/29/2007 23:16'!
enable
	enabled := self convention notNil.! !

!CMComponent methodsFor: 'testing' stamp: 'srh 5/29/2007 22:10'!
enabled
	^enabled! !

!CMComponent methodsFor: 'initialize-release' stamp: 'srh 5/29/2007 22:10'!
initialize
	super initialize.
	enabled := true.! !

!CMComponent methodsFor: 'rendering' stamp: 'srh 10/20/2008 23:45'!
lightbox: aComponent
	^super lightbox: aComponent! !

!CMComponent methodsFor: 'rendering' stamp: 'srh 9/21/2007 23:15'!
renderField: anInputType on: aSelector of: anObject titled: aTitle on: html 
	html div: 
			[(html label)
				class: #label;
				for: aSelector;
				with: aTitle , ': '.
			(html perform: anInputType)
				on: aSelector of: anObject;
				id: aSelector]! !

!CMComponent methodsFor: 'specialisation' stamp: 'srh 10/7/2007 20:49'!
title
	^self subclassResponsibility.! !

CMComponent subclass: #CMConfiguration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Conman-Web'!

!CMConfiguration methodsFor: 'as yet unclassified' stamp: 'srh 10/20/2008 23:44'!
renderContentOn: html
	html form: [
		html submitButton value: 'Save'.
	]! !

!CMConfiguration methodsFor: 'as yet unclassified' stamp: 'srh 5/31/2007 20:25'!
title
	^'Configuration'! !

CMComponent subclass: #CMConman
	instanceVariableNames: 'children content'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Conman-Web'!

!CMConman class methodsFor: 'as yet unclassified' stamp: 'srh 5/29/2007 21:45'!
canBeRoot
	^true! !

!CMConman class methodsFor: 'as yet unclassified' stamp: 'srh 6/5/2007 20:43'!
registerAsApplication: aString
	^(super registerAsApplication: aString)
		addLibrary: CMFileLibrary;
		addLibrary: SULibrary;
		preferenceAt: #sessionClass put: CMSession;
		yourself
! !

!CMConman methodsFor: 'as yet unclassified' stamp: 'srh 5/29/2007 22:04'!
children
	^Array with: content.! !

!CMConman methodsFor: 'as yet unclassified' stamp: 'srh 10/7/2007 20:48'!
initialize
	super initialize.
	children := OrderedCollection new.
	content := children add: CMHome new.
	children add: CMSchedule new.
	children add: CMRooms new.
	children add: CMParticipants new.
	children add: CMEvents new.
	children add: CMLoadSave new.
	children add: CMConfiguration new.! !

!CMConman methodsFor: 'as yet unclassified' stamp: 'srh 9/21/2007 20:33'!
renderContentOn: html 
	html script: (
		SUResponders new 
			onCreate: (SUSelector new do: [ :e | e element  addClassName: #busy]);
			onComplete: (SUSelector new do: [ :e | e element  removeClassName: #busy])
	).

	(html div)
		id: 'heading';
		with: [self renderHeadingOn: html].
	(html div)
		id: 'nav';
		with: [self renderNavOn: html].
	(html div)
		id: 'pageHeading';
		with: [self renderPageHeadingOn: html].
	(html div)
		id: 'pageBody';
		with: [self renderPageBodyOn: html]! !

!CMConman methodsFor: 'as yet unclassified' stamp: 'srh 10/20/2008 23:56'!
renderHeadingOn: html
	self convention isNil  
		ifTrue: [ html heading level: 1; with: [html space] ]
		ifFalse: [		 
			html heading 
				level: 1; 
				with: self convention name].
	html paragraph: 'Conman convention management system'! !

!CMConman methodsFor: 'as yet unclassified' stamp: 'srh 10/20/2008 23:48'!
renderNavOn: html.
	html unorderedList: [ 
		children do: [ :c | 
			| id |
			id := html nextId.
			c enabled ifTrue: [
				html listItem id: id; class: ((c = content) ifTrue:  ['active'] ifFalse: ['']); with: [ 
					html anchor 
						callback: [ content := c ]; 
						with: c title]]]]! !

!CMConman methodsFor: 'as yet unclassified' stamp: 'srh 6/3/2007 13:36'!
renderPageBodyOn: html 
	html render: content! !

!CMConman methodsFor: 'as yet unclassified' stamp: 'srh 6/3/2007 13:36'!
renderPageHeadingOn: html
	html heading level: 2; with: content title.! !

!CMConman methodsFor: 'as yet unclassified' stamp: 'srh 6/2/2007 23:04'!
updateRoot: anHtmlRoot
	| t |
	super updateRoot: anHtmlRoot.
	t := 'Conman'.
	self convention ifNotNil: [ t := t, ': ', self convention name ].
	anHtmlRoot 
		title: t.
	anHtmlRoot	stylesheet 
		url: CMFileLibrary  / #conmanCss! !

CMComponent subclass: #CMHome
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Conman-Web'!

!CMHome methodsFor: 'as yet unclassified' stamp: 'srh 5/29/2007 23:16'!
enabled
	^true! !

!CMHome methodsFor: 'as yet unclassified' stamp: 'srh 5/30/2007 21:50'!
renderContentOn: html
	self convention ifNotNil: [
		html paragraph: 'Events: ', self convention events size printString.
		html paragraph: 'Rooms: ', self convention rooms size printString.
		html paragraph: 'Participants: ', self convention participants size printString.
	]! !

!CMHome methodsFor: 'as yet unclassified' stamp: 'srh 5/29/2007 22:15'!
title
	^'Home'! !

CMComponent subclass: #CMListView
	instanceVariableNames: 'viewer list'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Conman-Web'!

CMListView subclass: #CMEvents
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Conman-Web'!

!CMEvents methodsFor: 'data-access' stamp: 'srh 5/31/2007 21:26'!
items
	^self convention events! !

!CMEvents methodsFor: 'rendering' stamp: 'srh 10/21/2008 23:45'!
setupColumns
	list	column on: #name.
	list column titled: 'Room';
			renderedUsing: 
				[ :item | 
				item scheduled 
					ifTrue: [ item room name ]
					ifFalse: [ '(unscheduled)' ] ];
			property: #colSpan value: [ :item | item scheduled ifTrue: [1] ifFalse: [3]];
			property: #style value: [ :item | item scheduled ifFalse: ['font-style: italic;text-align: center']].
	list	column titled: 'Day';
			renderedUsing: 
				[ :item | 
				item day dayOfWeekAbbreviation , ', ' , (item day date printFormat: #(2 1 0 ' ' 2 1)) ];
			onlyIf: [ :item | item scheduled ].
	list column titled: 'Time';
			renderedUsing:
				[ :item | (String streamContents: [ :aStream | item time print24: true showSeconds: false on: aStream ])];
			onlyIf: [ :item | item scheduled ].
	list column titled: 'Ptpts';
			renderedUsing: 
				[ :item | 
				(self session convention participants select: [ :p | p events includes: item ]) size printString ];
			property: #class value: 'num'! !

!CMEvents methodsFor: 'specialisation' stamp: 'srh 5/31/2007 21:13'!
title
	^'Events'! !

!CMEvents methodsFor: 'specialisation' stamp: 'srh 5/31/2007 22:31'!
viewerClass
	^CMEventView! !

!CMListView methodsFor: 'accessing' stamp: 'srh 10/20/2008 14:56'!
children
	^Array with: viewer with: list .! !

!CMListView methodsFor: 'testing' stamp: 'srh 5/31/2007 22:27'!
enabled
	^self convention notNil! !

!CMListView methodsFor: 'initialize-release' stamp: 'srh 10/21/2008 22:53'!
initialize
	super initialize.
	viewer := self viewerClass new.
	list := CMList new.
	self setupColumns.
	self setupActions.! !

!CMListView methodsFor: 'data-access' stamp: 'srh 5/31/2007 22:31'!
items
	^self subclassResponsibility.! !

!CMListView methodsFor: 'rendering' stamp: 'srh 10/20/2008 18:10'!
renderContentOn: html
	| odd | odd := true.
	list items: self items.
	html div id: #content; with: [ html div id: 'view'; with: viewer].
	html div id: #sidebar; with: list
! !

!CMListView methodsFor: 'initialize-release' stamp: 'srh 10/21/2008 22:52'!
setupActions
	list
		callback: [ :item | viewer item: item ];
		addAction: '(x)'
			callback: [ :item | viewer delete: item ];
		addListAction: 'Add'
			callback: [ viewer add ]! !

!CMListView methodsFor: 'initialize-release' stamp: 'srh 10/21/2008 22:52'!
setupColumns
	"Override this to set up the list"
	! !

!CMListView methodsFor: 'specialisation' stamp: 'srh 5/31/2007 22:30'!
viewerClass
	^self subclassResponsibility.! !

CMListView subclass: #CMParticipants
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Conman-Web'!

!CMParticipants methodsFor: 'data-access' stamp: 'srh 5/31/2007 23:58'!
items
	^self convention participants! !

!CMParticipants methodsFor: 'specialisation' stamp: 'srh 10/21/2008 23:09'!
setupColumns
	list	column on: #name.
	list	column titled: 'Events';
			renderedUsing: [ :item | item events size printString ];
			property: #class value: 'num'! !

!CMParticipants methodsFor: 'specialisation' stamp: 'srh 5/31/2007 21:07'!
title
	^'Participants'! !

!CMParticipants methodsFor: 'specialisation' stamp: 'srh 5/31/2007 23:59'!
viewerClass
	^CMParticipantView! !

CMListView subclass: #CMRooms
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Conman-Web'!

!CMRooms methodsFor: 'as yet unclassified' stamp: 'srh 6/1/2007 00:05'!
items
	^self convention rooms! !

!CMRooms methodsFor: 'as yet unclassified' stamp: 'srh 10/21/2008 23:09'!
setupColumns
	list	column on: #name.
	list	column titled: 'Events';
			renderedUsing: 	[ :item | (self session convention events select: [ :e | e room = item ]) size printString ];
			property: #class value: 'num'! !

!CMRooms methodsFor: 'as yet unclassified' stamp: 'srh 6/1/2007 00:03'!
title
	^'Rooms'! !

!CMRooms methodsFor: 'as yet unclassified' stamp: 'srh 6/1/2007 00:03'!
viewerClass
	^CMRoomView! !

CMComponent subclass: #CMLoadSave
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Conman-Web'!

!CMLoadSave methodsFor: 'as yet unclassified' stamp: 'srh 5/29/2007 23:16'!
enabled
	^true! !

!CMLoadSave methodsFor: 'as yet unclassified' stamp: 'srh 10/13/2008 21:15'!
renderContentOn: html
	self renderSaveBoxOn: html.
	self renderLoadListOn: html.
	self renderOtherOn: html! !

!CMLoadSave methodsFor: 'as yet unclassified' stamp: 'srh 10/13/2008 21:13'!
renderLoadListOn: html
	html form: [ html fieldSet legend: 'Load Convention'; with: [
		html select callback: [ :value | self session convention: (CMConvention loadFrom: value)  ];
			list: CMConvention listSaved.
		html submitButton value: 'Load'. ]].
	! !

!CMLoadSave methodsFor: 'as yet unclassified' stamp: 'srh 10/13/2008 21:15'!
renderOtherOn: html
	html fieldSet legend: 'Other Actions'; with: [
		html anchor callback: [ self session convention: nil ]; with: 'New Convention'.
	]! !

!CMLoadSave methodsFor: 'as yet unclassified' stamp: 'srh 10/13/2008 21:23'!
renderSaveBoxOn: html
	| con legend  |
	con := self session convention.
	legend := 'Update and Save'.
	con ifNil: [con := CMConvention new. legend := 'New Convention'] .

	html form: [
		html fieldSet legend: legend; with: [
		html label for: 'conname'; with: 'Convention Name: '.
		html textInput id: 'conname'; on: #name of: con.
		html label for: 'filename'; with: 'Filename: '.
		html textInput id: 'filename'; on: #filename of: con.
		html submitButton value: 'Save'; callback: [ con save. self session convention: con ].
		]
	].! !

!CMLoadSave methodsFor: 'as yet unclassified' stamp: 'srh 10/13/2008 20:47'!
title
	^'Convention'! !

CMComponent subclass: #CMSchedule
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Conman-Web'!

!CMSchedule methodsFor: 'as yet unclassified' stamp: 'srh 10/7/2007 20:51'!
enabled
	^self convention notNil! !

!CMSchedule methodsFor: 'as yet unclassified' stamp: 'srh 10/7/2007 20:50'!
title
	^'Schedule'! !

CMComponent subclass: #CMViewer
	instanceVariableNames: 'item mode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Conman-Web'!

CMViewer subclass: #CMEditor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Conman-Web'!

!CMEditor class methodsFor: 'instance creation' stamp: 'srh 5/31/2007 23:41'!
for: anItem
	^self new item: anItem! !

!CMEditor methodsFor: 'actions' stamp: 'srh 9/23/2007 17:51'!
add
	mode := #new.
	item := self newItem.! !

!CMEditor methodsFor: 'data-access' stamp: 'srh 9/23/2007 13:09'!
addItem: anItem
	^self subclassResponsibility.! !

!CMEditor methodsFor: 'actions' stamp: 'srh 9/23/2007 17:52'!
cancel
	(mode = #new) ifTrue: [ item := nil ].
	mode := #details! !

!CMEditor methodsFor: 'actions' stamp: 'srh 9/23/2007 13:02'!
delete: anObject
	(self lightbox: (WAYesOrNoDialog new addMessage: 'Are you sure you want to delete ', anObject name, '?'; yourself))
		ifTrue: [
			self removeItem: anObject.
		]! !

!CMEditor methodsFor: 'data-access' stamp: 'srh 9/23/2007 13:04'!
newItem
	^self subclassResponsibility.! !

!CMEditor methodsFor: 'data-access' stamp: 'srh 9/23/2007 13:04'!
removeItem: anItem
	^super subclassResponsibility.! !

!CMEditor methodsFor: 'as yet unclassified' stamp: 'srh 10/7/2007 20:32'!
renderContentOn: html
	((mode = #edit) or: [mode = #new]) ifFalse: [ super renderContentOn: html.] ifTrue: [
		html form: [
			self renderEditTitleOn: html.
			html div id: #viewContent; with: [	
				self renderEditFieldsOn: html.
				html submitButton on: #save of: self.
				html cancelButton on: #cancel of: self ]]
	]
! !

!CMEditor methodsFor: 'rendering' stamp: 'srh 5/31/2007 23:38'!
renderTextArea: aName for: aSelector on: html
	self renderField: #textArea on: aSelector  of: item titled: aName on: html! !

!CMEditor methodsFor: 'rendering' stamp: 'srh 5/31/2007 23:38'!
renderTextInput: aName for: aSelector on: html
	self renderField: #textInput on: aSelector  of: item titled: aName on: html! !

!CMEditor methodsFor: 'rendering' stamp: 'srh 9/21/2007 23:11'!
renderTitleField: aName for: aSelector on: html
	self renderField: #textInput on: aSelector  of: item titled: aName on: html! !

!CMEditor methodsFor: 'actions' stamp: 'srh 9/23/2007 17:57'!
save
	(mode = #new) ifTrue: [
		self addItem: item.
	].
	mode := #details! !

CMEditor subclass: #CMEventView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Conman-Web'!

!CMEventView methodsFor: 'data-access' stamp: 'srh 9/23/2007 13:05'!
addItem: anEvent
	self convention addEvent: anEvent! !

!CMEventView methodsFor: 'data-access' stamp: 'srh 9/23/2007 13:05'!
newItem
	^CMEvent new.! !

!CMEventView methodsFor: 'as yet unclassified' stamp: 'srh 10/21/2008 00:08'!
renderDetailsOn: html
	html paragraph class: #label; with: 'Info'.
	html paragraph: [html html:  self item description asHtml] .
! !

!CMEventView methodsFor: 'as yet unclassified' stamp: 'srh 9/23/2007 11:13'!
renderEditFieldsOn: html
	self renderTextArea: 'Info' for: #description on: html! !

!CMEventView methodsFor: 'as yet unclassified' stamp: 'srh 9/23/2007 11:25'!
renderEditTitleOn: html
	self renderTitleField: 'Name' for: #name on: html.! !

CMEditor subclass: #CMParticipantView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Conman-Web'!

!CMParticipantView methodsFor: 'data-access' stamp: 'srh 9/23/2007 13:08'!
addItem: anItem
	self convention addParticipant: anItem! !

!CMParticipantView methodsFor: 'as yet unclassified' stamp: 'srh 6/3/2007 22:07'!
initialize
	super initialize.
	mode := #details! !

!CMParticipantView methodsFor: 'as yet unclassified' stamp: 'srh 9/23/2007 10:32'!
modes
	^#(#events)! !

!CMParticipantView methodsFor: 'data-access' stamp: 'srh 9/23/2007 13:08'!
newItem
	^CMParticipant new! !

!CMParticipantView methodsFor: 'data-access' stamp: 'srh 9/23/2007 13:08'!
removeItem: anItem
	self convention removeParticipant: anItem! !

!CMParticipantView methodsFor: 'as yet unclassified' stamp: 'srh 10/21/2008 00:06'!
renderDetailsOn: html
	html paragraph class: #label; with: 'Bio'.
	html paragraph 
		with: [ html html: self item bio asHtml . ]
! !

!CMParticipantView methodsFor: 'as yet unclassified' stamp: 'srh 9/23/2007 11:13'!
renderEditFieldsOn: html
	self renderTextArea: 'Bio' for: #bio on: html.
! !

!CMParticipantView methodsFor: 'as yet unclassified' stamp: 'srh 9/23/2007 11:26'!
renderEditTitleOn: html
	self renderTitleField: 'Name' for: #name on: html.
! !

!CMParticipantView methodsFor: 'as yet unclassified' stamp: 'srh 10/19/2008 13:53'!
renderEventsOn: html
	| t lastDate |
	t := SortedCollection sortBlock: [ :a :b | 
		(a scheduled and: [ b scheduled ]) 
			ifTrue: [a time < b time] 
			ifFalse: [
				a scheduled 
					ifTrue: [b]
					ifFalse: [b scheduled ifTrue: [a] ifFalse: [ a name < b name ] ]
			]
	].
	item events do: [ :event | 
		t add: event
	].

	lastDate := nil.
	html table: [
		html 
			tableRow: [
				html 
					tableHeading: 'Date';
					tableHeading: 'Time';
					tableHeading: 'Event';
					tableHeading: 'Duration';
					tableHeading: 'Room'.
				].
		t do: [ :e |
			e scheduled ifTrue: [ 
				(lastDate = e day) 
					ifFalse: [ html tableData: e day dayOfWeekAbbreviation, ', ', (e day date printFormat: #(2 1 0 ' ' 2 1)) ] 
					ifTrue: [ html tableData ].
				html tableData: (String streamContents: [ :aStream | e time print24: true showSeconds: false on: aStream ]).
				lastDate := e day.
			] ifFalse: [
				(lastDate = #unscheduled) 
					ifFalse: [ html tableData colSpan: 2; with: '(Unscheduled)' ] 
					ifTrue: [ html tableData colSpan: 2].
				lastDate := #unscheduled.
			].
		
			html tableData: e name.
			html tableData: e duration.
			html tableData: (e scheduled ifTrue: [ e room name ])
		]
	]

"			tableData: anEvent time dayOfWeekAbbreviation, ', ', (anEvent time asDate printFormat: #(2 1 0 ' ' 2 1));
			tableData: (String streamContents: [ :aStream | anEvent time asTime print24: true showSeconds: false on: aStream ])
"! !

!CMParticipantView methodsFor: 'as yet unclassified' stamp: 'srh 5/30/2007 23:13'!
style ^ 'div#participantView {
    border-style: solid;
    border-width: 1px;
}

#participantView h3 {
    margin-top: 0;
}
'! !

CMEditor subclass: #CMRoomView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Conman-Web'!

!CMRoomView methodsFor: 'as yet unclassified' stamp: 'srh 9/23/2007 13:08'!
addItem: anItem
	^self convention addRoom: anItem! !

!CMRoomView methodsFor: 'as yet unclassified' stamp: 'srh 9/23/2007 13:09'!
newItem
	^CMRoom new! !

!CMRoomView methodsFor: 'as yet unclassified' stamp: 'srh 9/23/2007 13:09'!
removeItem: anItem
	^self convention removeRoom: anItem! !

!CMRoomView methodsFor: 'as yet unclassified' stamp: 'srh 10/21/2008 23:52'!
renderDetailsOn: html
	html paragraph class: #label; with: 'Capacity'.
	html paragraph: self item capacity.
		
	html paragraph class: #label; with: 'Info'.	
	html paragraph: [html html: self item description] .
! !

!CMRoomView methodsFor: 'as yet unclassified' stamp: 'srh 9/23/2007 11:13'!
renderEditFieldsOn: html
	self renderTextInput: 'Capacity' for: #capacity on: html.
	self renderTextArea: 'Description' for: #description on: html.
! !

!CMRoomView methodsFor: 'as yet unclassified' stamp: 'srh 9/23/2007 11:25'!
renderEditTitleOn: html
	self renderTitleField: 'Name' for: #name on: html.! !

!CMViewer class methodsFor: 'as yet unclassified' stamp: 'srh 5/31/2007 22:06'!
for: anItem
	^self new item: anItem; yourself.! !

!CMViewer methodsFor: 'rendering' stamp: 'srh 9/23/2007 10:46'!
allModes
	^(OrderedCollection with: #details) addAll: self modes; yourself! !

!CMViewer methodsFor: 'rendering' stamp: 'srh 9/23/2007 10:50'!
initialize
	super initialize.
	mode := #details.
	item := nil.! !

!CMViewer methodsFor: 'as yet unclassified' stamp: 'srh 5/31/2007 21:37'!
item
	^item! !

!CMViewer methodsFor: 'as yet unclassified' stamp: 'srh 5/31/2007 22:52'!
item: anItem
	item := anItem! !

!CMViewer methodsFor: 'as yet unclassified' stamp: 'srh 9/23/2007 10:32'!
modes
	^#()! !

!CMViewer methodsFor: 'rendering' stamp: 'srh 9/23/2007 11:31'!
renderContentOn: html
	item ifNotNil: [
		self renderHeadingOn: html.
			html unorderedList 
			class: #itemTabs;
			with: [ self renderNavOn: html ].
		html div 
			id: #viewContent; 
			with: [	self renderItemContentOn: html.	].
]! !

!CMViewer methodsFor: 'rendering' stamp: 'srh 10/21/2008 00:08'!
renderHeadingOn: html
	item ifNotNil: [
		html heading 
			level: 3;
		 	with: item name.
	]! !

!CMViewer methodsFor: 'rendering' stamp: 'srh 9/23/2007 10:55'!
renderItemContentOn: html
	self perform: ('render', mode capitalized , 'On:' ) asSymbol with: html.
	html span class: #fixFloats.
	(mode = #details) ifTrue: [
		html form: [ html submitButton value: 'Edit';callback: [ mode := #edit ] ]
	].
! !

!CMViewer methodsFor: 'rendering' stamp: 'srh 9/23/2007 11:18'!
renderNavOn: html
	self allModes do: [ :m |
		html listItem 
			class: ((mode = m) ifTrue: [#active]);
			with: [
				(mode = #edit) ifFalse: [
					html anchor 
						callback: [ mode := m ];
						with: m asCapitalizedPhrase.
				] ifTrue: [
					html span with: m asCapitalizedPhrase.
				]
			]
		].! !

WAComponent subclass: #CMList
	instanceVariableNames: 'columns actions listActions callback items'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Conman-Web-Components'!

!CMList methodsFor: 'as yet unclassified' stamp: 'srh 10/21/2008 00:28'!
addAction: name callback: aBlock
	actions add: name -> aBlock! !

!CMList methodsFor: 'as yet unclassified' stamp: 'srh 10/21/2008 00:18'!
addListAction: name callback: aBlock
	listActions add: name -> aBlock! !

!CMList methodsFor: 'as yet unclassified' stamp: 'srh 10/20/2008 22:15'!
callback: aBlock
	"Callback called when an item is selected - passed the item"
	callback := aBlock! !

!CMList methodsFor: 'as yet unclassified' stamp: 'srh 10/21/2008 23:10'!
column
	^columns add: CMListColumn new.! !

!CMList methodsFor: 'initialize-release' stamp: 'srh 10/19/2008 23:01'!
initialize
	super initialize.
	columns := OrderedCollection new.
	actions := OrderedCollection new.
	listActions := OrderedCollection new.
	items := OrderedCollection new.! !

!CMList methodsFor: 'accessing' stamp: 'srh 10/20/2008 14:55'!
items
	^items! !

!CMList methodsFor: 'rendering' stamp: 'srh 10/20/2008 18:07'!
items: aCollection
	items := aCollection! !

!CMList methodsFor: 'rendering' stamp: 'srh 10/21/2008 00:29'!
renderActionsFor: anItem on: html
	html tableData class: 'actions'; with: [ 
		actions do: [:action| 
			html anchor callback: [action value value: anItem]; with: action key
		]
	].
! !

!CMList methodsFor: 'rendering' stamp: 'srh 10/21/2008 22:37'!
renderContentOn: html
	| odd | odd := true.
		html table: [
			html tableRow class: #head; with: [ self renderHeadersOn: html. html tableHeading: '' ].
			self items do: [ :i | 
				html tableRow 
					class: ( odd ifTrue: [ #odd ] ifFalse: [ #even ] );
					with: [ 
						columns do: [:c | c renderItem: i on: html callback: callback ].
						self renderActionsFor: i on: html ].
				odd := odd not.
			]
		].
		listActions do: [:action | html anchor callback: action value; with: action key]
! !

!CMList methodsFor: 'rendering' stamp: 'srh 10/19/2008 22:37'!
renderHeadersOn: html
	columns do: [:column | html tableHeading: column title]! !

WASession subclass: #CMSession
	instanceVariableNames: 'convention ajax inlineEdit'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Conman-Web'!

!CMSession methodsFor: 'as yet unclassified' stamp: 'srh 5/29/2007 22:18'!
convention
	^convention.! !

!CMSession methodsFor: 'as yet unclassified' stamp: 'srh 5/29/2007 22:18'!
convention: aCMConvention
	convention := aCMConvention.! !

!CMSession methodsFor: 'as yet unclassified' stamp: 'srh 10/19/2008 21:55'!
initialize
	super initialize.
	ajax := false.
	inlineEdit := true.! !

TestCase subclass: #CMConventionTest
	instanceVariableNames: 'c e r p time d'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Conman-Core-Tests'!

!CMConventionTest methodsFor: 'as yet unclassified' stamp: 'srh 10/19/2008 13:07'!
assertDeserialization: c2
	" Check that c2 is the same as c as set up by standardSetUp"
	| e2 r2 p2 d2 tt |

	self assert: c name = c2 name.
	
	" Verify the basic collections are the same - as far as we can "
	self assert: c rooms size = c2 rooms size.
	self assert: c events size = c2 events size.
	self assert: c participants size = c2 participants size .
	self assert: c days size = c2 days size .
	
	" Now ensure the relationships are kept "
	e2 := c2 events asOrderedCollection at: 1.
	r2 := c2 rooms asOrderedCollection at: 1.
	p2 := c2 participants asOrderedCollection at: 1.
	d2 := c2 days asOrderedCollection at: 1.
	tt := p2 timetable at: 1.
		
	self assert: r2 = e2 room.
	self assert: e2 = (p2 events asOrderedCollection at: 1).
	self assert: e2 = tt.
	self assert: d2 = e2 day.
	self assert: r2 = tt room.
	self assert: time  = tt time.
	! !

!CMConventionTest methodsFor: 'as yet unclassified' stamp: 'srh 10/19/2008 12:44'!
setUp
	c := CMConvention new name: 'A Convention'.
	e := CMEvent new name: 'An Event'; description: 'Stuff Happens'.
	r := CMRoom new name: 'A Room'; description: 'It has four walls'; capacity: '20'.
	p := CMParticipant new name: 'A Participant'.
	d := CMDay date: '1 Oct 2007' asDate.
	time := '12:00:00' asTime.
! !

!CMConventionTest methodsFor: 'as yet unclassified' stamp: 'srh 10/19/2008 12:53'!
standardSetUp
	c addEvent: e; addRoom: r; addParticipant: p; addDay: d.
	p attend: e.
	e scheduleOn: d at: time in: r.
! !

!CMConventionTest methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 22:17'!
tearDown
	c := nil.
	e := nil.
	r := nil.
	p := nil.
	time := nil.! !

!CMConventionTest methodsFor: 'as yet unclassified' stamp: 'srh 10/19/2008 12:47'!
testAddDays
	c addDay: d.
	self assert: (c days includes: d).! !

!CMConventionTest methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 21:00'!
testAddEvents
	c addEvent: e.
	self assert: (c events includes: e).! !

!CMConventionTest methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 21:00'!
testAddParticipants
	c addParticipant: p.
	self assert: (c participants includes: p).! !

!CMConventionTest methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 21:00'!
testAddRooms
	c addRoom: r.
	self assert: (c rooms includes: r).! !

!CMConventionTest methodsFor: 'as yet unclassified' stamp: 'srh 10/19/2008 13:14'!
testLoadSave
	| c2 |
	self standardSetUp.
	c saveAs: 'testingfile'.
	
	c2 := CMConvention loadFrom: 'testingfile'.
	self assertDeserialization: c2.! !

!CMConventionTest methodsFor: 'as yet unclassified' stamp: 'srh 10/19/2008 12:48'!
testRemoveDay
	self standardSetUp.
		
	c removeDay: d.
	
	self assert: (c days includes: r) not.
	self assert: (e scheduled) not.
	self assert: e day isNil.
	self assert: (p timetable noneSatisfy: [ :s | s day = d ]).! !

!CMConventionTest methodsFor: 'as yet unclassified' stamp: 'srh 10/19/2008 12:46'!
testRemoveEvent
	self	standardSetUp.
	c removeEvent: e.
	
	self assert: (c events includes: e) not.
	self assert: (p events includes: e) not.! !

!CMConventionTest methodsFor: 'as yet unclassified' stamp: 'srh 10/19/2008 12:46'!
testRemoveParticipant
	self standardSetUp.
	
	c removeParticipant: p.
	
	self assert: (c participants includes: p) not.
! !

!CMConventionTest methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 22:18'!
testRemoveRoom
	self standardSetUp.
		
	c removeRoom: r.
	
	self assert: (c rooms includes: r) not.
	self assert: (e scheduled) not.
	self assert: e room isNil.
	self assert: (p timetable noneSatisfy: [ :s | s room = r ]).! !

!CMConventionTest methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 22:19'!
testSerialiseDeserialise
	| c2 string |
	self standardSetUp.
	string := c serialize.
	
	c2 := CMConvention deserialize: string.
	self assertDeserialization: c2.! !

TestCase subclass: #CMDayTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Conman-Core-Tests'!

!CMDayTest methodsFor: 'as yet unclassified' stamp: 'srh 10/19/2008 11:56'!
testDay
	| day date |
	date := '19 Oct 2008' asDate.
	day := CMDay date: date.
	
	self assert: day date equals: date.! !

!CMDayTest methodsFor: 'as yet unclassified' stamp: 'srh 10/19/2008 13:56'!
testDayOfWeekAbbreviation
	| d| 
	d := CMDay date: '19 Oct 2008' asDate.
	self assert: 'Sun' equals: d dayOfWeekAbbreviation.! !

TestCase subclass: #CMEventTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Conman-Core-Tests'!

!CMEventTest methodsFor: 'as yet unclassified' stamp: 'srh 10/19/2008 12:32'!
assert: anEvent scheduledOn: aDay at: aTime in: aRoom
	self assert: anEvent scheduled.
	self assert: anEvent time equals: aTime.
	self assert: anEvent day equals: aDay.
	self assert: anEvent room equals: aRoom! !

!CMEventTest methodsFor: 'as yet unclassified' stamp: 'srh 10/19/2008 12:33'!
testDeschedule
	| e1 r1 |
	r1 := CMRoom new.
	e1 := CMEvent new.
	
	e1 scheduleOn: '1 OCt 2007' asDate at: '9:00:00' asTime in: r1.	
	e1 deschedule.
	self assert: e1 scheduled not
	
! !

!CMEventTest methodsFor: 'as yet unclassified' stamp: 'srh 10/19/2008 12:33'!
testInitalState
	self assert: CMEvent new scheduled not.! !

!CMEventTest methodsFor: 'as yet unclassified' stamp: 'srh 10/19/2008 12:37'!
testReschedule
	| e1 r1 r2 t1 t2 d1 d2|
	r1 := CMRoom new.
	r2 := CMRoom new.
	e1 := CMEvent new.
	d1 := '1 Oct 2007' asDate.
	d2 := '2 Oct 2008' asDate.
	t1 := '9:00:00' asTime.
	t2 := '17:00:00' asTime.
	
	e1 scheduleOn: d1 at: t1 in: r1.	
	e1 scheduleOn: d2 at: t2 in: r2.
	
	self assert: e1 scheduled.
	self assert: e1 scheduledOn: d2 at: t2 in: r2.
	! !

!CMEventTest methodsFor: 'as yet unclassified' stamp: 'srh 10/19/2008 12:35'!
testSchedule
	| e1 r1 t1 d1 |
	r1 := CMRoom new.
	e1 := CMEvent new.
	d1 := '1 Oct 2007' asDate.
	t1 := '9:00:00' asTime.
	
	e1 scheduleOn: d1 at: t1 in: r1.	
	self assert: e1 scheduled.
	self assert: e1 scheduledOn: d1 at: t1 in: r1.
! !

TestCase subclass: #CMParticipantTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Conman-Core-Tests'!

!CMParticipantTest methodsFor: 'as yet unclassified' stamp: 'srh 10/19/2008 12:14'!
testAttend
	| p e |
	e := CMEvent new.
	p := CMParticipant new.
	p attend: e.
	self assert: p events size = 1.
	self assert: (p events includes: e).! !

!CMParticipantTest methodsFor: 'as yet unclassified' stamp: 'srh 10/19/2008 12:27'!
testTimetable
	| e1 r1 e2 r2 p t1 t2 d1 d2 |
	
	p := CMParticipant new.
	e1 := CMEvent new.
	e2 := CMEvent new.
	r1 := CMRoom new.
	r2 := CMRoom new.
	d1 := Date newDay: 1 month:  10 year: 2007.
	d2 := Date newDay: 2 month:  10 year: 2007.
	t1 := '9:30:00' asTime.
	t2 := '5:00:00' asTime.

	e1 scheduleOn: d1 at: t1 in: r1.
	e2 scheduleOn: d2 at: t2 in: r2.
	
	p attend: e1.
	p attend: e2.
	
	self assert: (p timetable at: 1) room = r1.
	self assert: (p timetable at: 1) = e1.
	self assert: (p timetable at: 1) time = t1.
	self assert: (p timetable at: 1) day = d1.
	
	self assert: (p timetable at: 2) room = r2.
	self assert: (p timetable at: 2) = e2.
	self assert: (p timetable at: 2) time = t2.
	self assert: (p timetable at: 2) day = d2.! !

!CMParticipantTest methodsFor: 'as yet unclassified' stamp: 'srh 10/19/2008 12:15'!
testUnattend
	| e1 p1 |
	p1 := CMParticipant new.
	e1 := CMEvent new.
	
	p1 attend: e1.
	p1 unattend: e1.
	self assert: p1 events size = 0.! !

TestCase subclass: #CMRoomTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Conman-Core-Tests'!
CMConvention initialize!
